import sys
from osgeo import ogr

def add_fields_upgrade():
    #
    # Ouvrir le GeoPackage en mode édition
    geopackage = ogr.Open("c:/enc_db/ENC4.gpkg", 1)
    
    if geopackage is not None:
        # Récupérer le nombre de tables dans le GeoPackage
        num_tables = geopackage.GetLayerCount()

        # Liste des tables à supprimer
        
        tables_to_update = []

        # Identifier les tables à supprimer
        for i in range(num_tables):
            table = geopackage.GetLayerByIndex(i)
            if  table.GetName().startswith('pt_') or table.GetName().startswith('li_'): 
                tables_to_update.append(table.GetName())

        # Mettre à jour les tables restantes
        for table_name in tables_to_update:
            table = geopackage.GetLayerByName(table_name)

            # Vérifier si le champ 'posacc' existe
            posacc_index = table.FindFieldIndex('POSACC', 1)
            if posacc_index < 0:
                # Ajouter le champ 'posacc' s'il n'existe pas
                champ5 = ogr.FieldDefn('POSACC', ogr.OFTReal)
                champ5.SetWidth(10)
                champ5.SetPrecision(2)
                table.CreateField(champ5)
            # Vérifier si le champ 'quapos' existe
            quapos_index = table.FindFieldIndex('QUAPOS', 1)
            if quapos_index < 0:
                # Ajouter le champ 'quapos' s'il n'existe pas
                champ6 = ogr.FieldDefn('QUAPOS', ogr.OFTReal)
                champ6.SetWidth(10)
                champ6.SetPrecision(2)
                table.CreateField(champ6)
        print(f"POSACC  ET QUAPOS ajoutés à {table_name}")                    

        # Fermer le GeoPackage
        geopackage = None

    else:
        print(f"Impossible d'ouvrir le GeoPackage {geopackage_path} en mode édition.")
add_fields_upgrade()