@echo off
setlocal enabledelayedexpansion

REM Assurez-vous qu'au moins 2 arguments ont été fournis
if "%~2"=="" (
    echo Usage: %0 directory000 output_geopackage 
    exit /b 1
)

REM Récupérer les arguments de la ligne de commande
set "directory=%~1"
set "output_geopackage=%~2"

REM Compter le nombre total de fichiers à traiter
set /a total_files=0
for /r "%directory%" %%a in (*.000) do (
    set /a total_files+=1
)

REM Initialiser le compteur de fichiers traités
set /a processed_files=0
REM Itérez sur tous les fichiers .000 dans le répertoire
for /r "%directory%" %%i in (*.000) do (
    echo Traitement du fichier: %%~ni
	set /a processed_files+=1
    echo Traitement en cours : !processed_files! sur !total_files!
	set "file=%%~ni"
    ogr2ogr -f GPKG -skipfailures -append -update -oo RETURN_PRIMITIVES=ON -nlt MULTIPOINT "%output_geopackage%" "%%i" IsolatedNode ConnectedNode 
	ogr2ogr -f GPKG -skipfailures -append -update -oo RETURN_PRIMITIVES=ON -nlt LINESTRING "%output_geopackage%" "%%i" Edge
 
)
echo Import terminé. Ajout de posacc et quapos.

pause
